#include "stdafx.h"
#include "NeMessenger.h"
#include "NFontDialog.h"

#define FONT_DLG_WIDTH		310
#define FONT_DLG_HEIGHT		250

#define BTN_WIDTH		70
#define BTN_HEIGHT		30
#define BTN_GAP			10		// ư 2 ̻   


IMPLEMENT_DYNAMIC(CNFontDialog, CDialog)

CNFontDialog::CNFontDialog(CHARFORMAT2& charformat, CWnd* pParent /*=NULL*/)
	: CDialog(CNFontDialog::IDD, pParent)
{
	m_cf = charformat;
	m_pParentChatWnd = pParent;
}

CNFontDialog::~CNFontDialog()
{
	m_penBorder.DeleteObject();
}

void CNFontDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_FontPreviewCombo (pDX, IDC_COMBO_FACE, m_faceName);
	DDX_Control(pDX, IDC_COMBO_FACE, m_cbFace);
	DDX_Control(pDX, IDC_COMBO_SIZE, m_cbSize);
	DDX_Control(pDX, IDC_COMBO_COLOR, m_cbColor);
	DDX_Control(pDX, IDC_BUTTON_BOLD, m_bnBold);
	DDX_Control(pDX, IDC_BUTTON_UNDERLINE, m_bnUnderLine);
	DDX_Control(pDX, IDC_BUTTON_ITALIC, m_bnItalic);
	DDX_Control(pDX, IDC_BUTTON_STRIKEOUT, m_bnStrikeout);
	DDX_Control(pDX, IDOK, m_bnOK);
	DDX_Control(pDX, IDCANCEL, m_bnCancel);
}


BEGIN_MESSAGE_MAP(CNFontDialog, CDialog)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_CBN_SELCHANGE(IDC_COMBO_FACE, &CNFontDialog::OnCbnSelchangeComboFace)
	ON_CBN_SELCHANGE(IDC_COMBO_SIZE, &CNFontDialog::OnCbnSelchangeComboSize)
	ON_CBN_SELCHANGE(IDC_COMBO_COLOR, &CNFontDialog::OnCbnSelchangeComboColor)
	ON_BN_CLICKED(IDC_BUTTON_BOLD, &CNFontDialog::OnBnClickedButtonBold)
	ON_BN_CLICKED(IDC_BUTTON_UNDERLINE, &CNFontDialog::OnBnClickedButtonUnderline)
	ON_BN_CLICKED(IDC_BUTTON_ITALIC, &CNFontDialog::OnBnClickedButtonItalic)
	ON_BN_CLICKED(IDC_BUTTON_STRIKEOUT, &CNFontDialog::OnBnClickedButtonStrikeout)
	ON_WM_KILLFOCUS()
	ON_WM_ACTIVATE()
END_MESSAGE_MAP()


BOOL CNFontDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(LoadStringFromResource(IDS_STRING354));

	InitControl();
	SetFontWindowPos();
	SetSkin();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CNFontDialog::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();
	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CNFontDialog::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient;
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	// ֻ μ
	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);

	// ϴ μ
	memDC.MoveTo(0, rcClient.bottom - 48);
	memDC.LineTo(rcClient.right, rcClient.bottom - 48);

	// Ʈ  ǥ  ׵θ
	memDC.Rectangle(&m_rtSampleBox);

	// Font 
	CFont* pOldFont;

	pOldFont = memDC.SelectObject(&g_ftDefault10PT);
	memDC.SetTextColor(RGB(34,34,34));
	memDC.SetBkMode(TRANSPARENT);

	// ޽ 
	memDC.DrawText(LoadStringFromResource(IDS_STRING354), CRect(17, 32, 56, 50), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING355), CRect(194, 32, 233, 50), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING356), CRect(17, 72, 56, 100), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING357), CRect(194, 72, 233, 100), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);

	CFont ftFont;
	ftFont.CreateFont(-MulDiv(m_cf.yHeight / 20, dc.GetDeviceCaps(LOGPIXELSY), 72), 0, 0, 0, (m_cf.dwEffects&CFE_BOLD ? FW_BOLD : FW_NORMAL), 
		(m_cf.dwEffects&CFE_ITALIC ? TRUE : FALSE), (m_cf.dwEffects&CFE_UNDERLINE? TRUE : FALSE), (m_cf.dwEffects&CFE_STRIKEOUT ? TRUE : FALSE), 
		HANGUL_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, CLEARTYPE_QUALITY, m_cf.bPitchAndFamily, m_cf.szFaceName);
	pOldFont = memDC.SelectObject(&ftFont);
	memDC.SetTextColor(m_cf.crTextColor);

	memDC.DrawText(LoadStringFromResource(IDS_STRING358), m_rtSampleBox, DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldFont);
	ftFont.DeleteObject();
	memDC.SelectObject(pOldPen);
}

BOOL CALLBACK FD_EnumFontProc (LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData)	
{
	CNFontDialog *pThis = reinterpret_cast<CNFontDialog*>(lpData);		

	if (lplf->lfFaceName[0] == _T('@'))
		return TRUE;

	int index = pThis->m_cbFace.AddString(lplf->lfFaceName);

	return TRUE;
}

void CNFontDialog::InitControl()
{
	// ۲ 
	CClientDC dc(this);
	EnumFonts(dc, 0, (FONTENUMPROC)FD_EnumFontProc, (LPARAM)this); //Enumerate font
	m_cbFace.SetFont(&g_ftDefault9PT);

	int nItem = 0;
	nItem = m_cbFace.FindString(nItem, m_cf.szFaceName);

	if (nItem != CB_ERR)
		m_cbFace.SetCurSel(nItem);
	else 
	{
		nItem = m_cbFace.FindString(nItem, g_defaultFontFaceName);

		if (nItem != CB_ERR)
			m_cbFace.SetCurSel(nItem);
	}

	// ũ
	m_cbSize.SetFont(&g_ftDefault9PT);
	int nSize[] = {8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, -1};
	CString strSize;

	for (int i = 0; nSize[i] != -1; i++)
	{
		strSize.Format(_T("%d"), nSize[i]);
		m_cbSize.AddString(strSize);
	}
	nItem = 0;
	strSize.Format(_T("%d"), m_cf.yHeight / 20);
	nItem = m_cbSize.FindString(nItem, strSize);

	if (nItem != CB_ERR)
		m_cbSize.SetCurSel(nItem);
	else
		m_cbSize.SetCurSel(2);

	// 
	m_cbColor.InitializeDefaultColors();
	m_cbColor.SetSelectedColorValue(m_cf.crTextColor);

	m_bnBold.SetTabBitmapFile(GetAppImgFile(_T("Chat_btn_font_bold.bmp")), RGB(0,0,0));
	m_cf.dwEffects&CFE_BOLD ? m_bnBold.SetTapSelected() : m_bnBold.SetTapUnSelected();
	m_bnUnderLine.SetTabBitmapFile(GetAppImgFile(_T("Chat_btn_font_underline.bmp")), RGB(0,0,0));
	m_cf.dwEffects&CFE_UNDERLINE? m_bnUnderLine.SetTapSelected() : m_bnUnderLine.SetTapUnSelected();
	m_bnItalic.SetTabBitmapFile(GetAppImgFile(_T("Chat_btn_font_italic.bmp")), RGB(0,0,0));
	m_cf.dwEffects&CFE_ITALIC ? m_bnItalic.SetTapSelected() : m_bnItalic.SetTapUnSelected();
	m_bnStrikeout.SetTabBitmapFile(GetAppImgFile(_T("Chat_btn_font_strikeout.bmp")), RGB(0,0,0));
	m_cf.dwEffects&CFE_STRIKEOUT ? m_bnStrikeout.SetTapSelected() : m_bnStrikeout.SetTapUnSelected();

	m_bnOK.SetFont(&g_ftDefault10PT);
	m_bnCancel.SetFont(&g_ftDefault10PT);

	m_penBorder.CreatePen(PS_SOLID, 1, RGB(220,220,220));
}

void CNFontDialog::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if (this->GetSafeHwnd() == NULL)
		return;

	CRect rcClient;
	GetClientRect(&rcClient);

	m_rtSampleBox = CRect(17, 110, rcClient.right - 17, 160);

	if (m_cbFace.GetSafeHwnd())
		m_cbFace.MoveWindow(57, 30, 127, 18);

	if (m_cbSize.GetSafeHwnd())
		m_cbSize.MoveWindow(234, 30, 53, 18);

	if (m_cbColor.GetSafeHwnd())
		m_cbColor.MoveWindow(234, 70, 53, 18);

	CRect rtBtn;
	if (m_bnBold.GetSafeHwnd() &&
		m_bnUnderLine.GetSafeHwnd() &&
		m_bnItalic.GetSafeHwnd() &&
		m_bnStrikeout.GetSafeHwnd())
	{
		rtBtn.left = 57;
		rtBtn.right = rtBtn.left + m_bnBold.GetWidth();
		rtBtn.top = 70;
		rtBtn.bottom = rtBtn.top + m_bnBold.GetHeight();

		m_bnBold.MoveWindow(rtBtn);
		m_bnBold.Invalidate();

		rtBtn.left = rtBtn.right;
		rtBtn.right = rtBtn.left + m_bnUnderLine.GetWidth();

		m_bnUnderLine.MoveWindow(rtBtn);
		m_bnUnderLine.Invalidate();

		rtBtn.left = rtBtn.right;
		rtBtn.right = rtBtn.left + m_bnItalic.GetWidth();

		m_bnItalic.MoveWindow(rtBtn);
		m_bnItalic.Invalidate();

		rtBtn.left = rtBtn.right;
		rtBtn.right = rtBtn.left + m_bnStrikeout.GetWidth();

		m_bnStrikeout.MoveWindow(rtBtn);
		m_bnStrikeout.Invalidate();
	}

	if (m_bnOK.GetSafeHwnd() && m_bnCancel.GetSafeHwnd())
	{
		rtBtn.left = (rcClient.Width() / 2) - (BTN_GAP / 2) - BTN_WIDTH; 
		rtBtn.right = rtBtn.left + BTN_WIDTH;
		rtBtn.bottom = rcClient.bottom - 7;
		rtBtn.top = rtBtn.bottom - BTN_HEIGHT;
		m_bnOK.MoveWindow(rtBtn);

		rtBtn.left = (rcClient.Width() / 2) + (BTN_GAP / 2); 
		rtBtn.right = rtBtn.left + BTN_WIDTH;
		rtBtn.bottom = rcClient.bottom - 7;
		rtBtn.top = rtBtn.bottom - BTN_HEIGHT;
		m_bnCancel.MoveWindow(rtBtn);
	}

}

void CNFontDialog::GetCharFormat(CHARFORMAT2& cf) 
{
	memcpy(&cf, &m_cf, sizeof(CHARFORMAT2));	
}

CString CNFontDialog::GetFaceName()
{
	CString strFaceName = g_defaultFontFaceName;

	if (m_cbFace.GetCount() > 0)
	{
		int nSel = m_cbFace.GetCurSel();

		if (nSel != CB_ERR)
		{
			m_cbFace.GetLBText(nSel, strFaceName);
		}
	}

	return strFaceName;
}

LONG CNFontDialog::GetSize()
{
	LONG lSize = 10 * 20;

	if (m_cbSize.GetCount() > 0)
	{
		int nSel = m_cbSize.GetCurSel();

		if (nSel != CB_ERR)
		{
			CString strSize;
			m_cbSize.GetLBText(nSel, strSize);
			lSize = _ttol(strSize) * 20;
		}
	}

	return lSize;
}

void CNFontDialog::OnOK()
{
	UpdateFontData();
	m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDOK, 0);
}

void CNFontDialog::OnCancel()
{
	m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDCANCEL, 0);
}

void CNFontDialog::UpdateFontData()
{
	m_cf.dwEffects = 0;
	m_cf.dwMask = 0;

	m_cf.dwMask |= CFM_FACE;
	//m_cf.bPitchAndFamily = m_cf.lpLogFont->lfPitchAndFamily;
	_tcscpy_s(m_cf.szFaceName, _countof(m_cf.szFaceName), GetFaceName().GetBuffer());

	m_cf.dwMask |= CFM_SIZE;
	m_cf.yHeight = GetSize();

	m_cf.dwMask |= CFM_COLOR;
	m_cf.crTextColor = m_cbColor.GetSelectedColorValue();
	m_cf.bCharSet |= HANGUL_CHARSET;

	m_cf.dwMask |= CFM_BOLD;
	m_cf.dwEffects |= (m_bnBold.GetSelected()) ? CFE_BOLD : 0;

	m_cf.dwMask |= CFM_ITALIC;
	m_cf.dwEffects |= (m_bnItalic.GetSelected()) ? CFE_ITALIC : 0;

	m_cf.dwMask |= CFM_UNDERLINE;
	m_cf.dwEffects |= (m_bnUnderLine.GetSelected()) ? CFE_UNDERLINE : 0;

	m_cf.dwMask |= CFM_STRIKEOUT;
	m_cf.dwEffects |= (m_bnStrikeout.GetSelected()) ? CFE_STRIKEOUT : 0;

	/*
	if ((m_cf.Flags & CF_NOSCRIPTSEL) == 0)
	{
	m_cf.bCharSet = m_cf.lpLogFont->lfCharSet;
	m_cf.dwMask |= CFM_CHARSET;
	}
	*/
	m_cf.yOffset = 0;
}

void CNFontDialog::OnCbnSelchangeComboFace()
{
	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnCbnSelchangeComboSize()
{
	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnCbnSelchangeComboColor()
{
	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnBnClickedButtonBold()
{
	if (m_bnBold.GetSelected())
		m_bnBold.SetTapUnSelected();
	else
		m_bnBold.SetTapSelected();

	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnBnClickedButtonUnderline()
{
	if (m_bnUnderLine.GetSelected())
		m_bnUnderLine.SetTapUnSelected();
	else
		m_bnUnderLine.SetTapSelected();

	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnBnClickedButtonItalic()
{
	if (m_bnItalic.GetSelected())
		m_bnItalic.SetTapUnSelected();
	else
		m_bnItalic.SetTapSelected();

	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

void CNFontDialog::OnBnClickedButtonStrikeout()
{
	if (m_bnStrikeout.GetSelected())
		m_bnStrikeout.SetTapUnSelected();
	else
		m_bnStrikeout.SetTapSelected();

	UpdateFontData();
	RedrawWindow(&m_rtSampleBox, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
}

BOOL CNFontDialog::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDCANCEL, 0);
			return TRUE;
		}
	}
	else if (IsCloseMsg(pMsg))
	{
		m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDCANCEL, 0);
		return TRUE;
	}
	else if (pMsg->message == WM_KILLFOCUS)
	{
		int a = 0;
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CNFontDialog::OnKillFocus(CWnd* pNewWnd)
{
	CDialog::OnKillFocus(pNewWnd);

	m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDCANCEL, 0);
}

bool CNFontDialog::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CNFontDialog::SetFontWindowPos()
{
	// â ġ  ȭâ  ġ ؾ Ѵ.
	const UINT uDlgWidth = FONT_DLG_WIDTH;
	const UINT uDlgHeight = FONT_DLG_HEIGHT;

	CRect rtParent;
	m_pParentChatWnd->GetWindowRect(&rtParent);

	BOOL bZoomed = m_pParentChatWnd->IsZoomed();
	int nPrimaryWidth = GetSystemMetrics(SM_CXSCREEN);
	int nPrimaryHeight = GetSystemMetrics(SM_CYSCREEN);

	// äâ ʿ  ִ  ʿ ̰,    ʿ δ
	int nSX = 0;
	int nSY = rtParent.bottom - uDlgHeight;

	if (bZoomed)
	{
		nSX = rtParent.left + 66;
		nSY = rtParent.bottom - uDlgHeight - DEF_CHAT_SEND_HEIGHT - 6;
	}
	else if (rtParent.left >= uDlgWidth)	
		nSX = rtParent.left - uDlgWidth;
	else
		nSX = rtParent.right;

	MoveWindow(nSX, nSY, uDlgWidth, uDlgHeight);
}

void CNFontDialog::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);

	if (nState == WA_INACTIVE)
		m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDCANCEL, 0);
}

void CNFontDialog::__ResourceLoad(BOOL bInit)
{
	SetWindowText(LoadStringFromResource(IDS_STRING354));	
	if (m_bnOK.GetSafeHwnd())
	{
		m_bnOK.SetFont(&g_ftDefault12PX);
		m_bnOK.SetWindowText(LoadStringFromResource(IDS_STRING568));
	}
	if (m_bnCancel.GetSafeHwnd())
	{
		m_bnCancel.SetFont(&g_ftDefault12PX);
		m_bnCancel.SetWindowText(LoadStringFromResource(IDS_STRING569));
	}

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}
